<?php
/*
+---------------------------------------------------------------+
|	For e107 website system
|	Teamspeak 3 Viewer for e107
|       Based on TeamSpeak 3 PHP Framework by ScP
|	http://forum.teamspeak.com/showthread.php?t=48162
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/
$eplug_admin = true;
if(!defined("e107_INIT")) {
	require_once("../../class2.php");
}

//For admin menu and v0.7
        $pageid = "ts3client";  // unique name that matches the one used in admin_menu.php.
$eplug_css="";

if(!getperms("P")){ header("location:".e_BASE."index.php");}
require_once(e_ADMIN."auth.php");

// Set languages --------------------------------------------+
$ec_dir = e_PLUGIN."teamspeak3_menu/";
$lan_file = $ec_dir."/languages/".e_LANGUAGE.".php";
include(file_exists($lan_file) ? $lan_file : e_PLUGIN."teamspeak3_menu/languages/English.php");

// Main settings -----------------------------------------+
/* load framework library and other*/
//require_once("./globals.php");
require_once("libraries/TeamSpeak3/TeamSpeak3.php");
/* initialize */
TeamSpeak3::init();

try
{
     $ssid = "0";
     $post_check = false;
     //Poke client action
     if(IsSet($_POST['send']))
     {
         extract($_POST);
         /* connect to server, login and get TeamSpeak3_Node_Host object by URI */
         $ts3_ServerInstance = TeamSpeak3::factory("serverquery://" . $pref['ts3_user'] . ":" . $pref['ts3_pass'] . "@" . $pref['ts3_ip'] . ":" . $pref['ts3_port'] . "/");
         $ts3_VirtualServer = $ts3_ServerInstance->serverGetById($ssid);
         $ts3_VirtualServer->clientPoke($cid, $poke);
         $post_check = true;
     }

  /* connect to server, login and get TeamSpeak3_Node_Host object by URI */
  $ts3_ServerInstance = TeamSpeak3::factory("serverquery://" . $pref['ts3_user'] . ":" . $pref['ts3_pass'] . "@" . $pref['ts3_ip'] . ":" . $pref['ts3_port'] . "/");

  /* display server select form */
  $return = form_server_selector($ts3_ServerInstance->serverList(), $ssid);
  
  if(!$post_check)
  {
     $selected_sid = $return['sid'];

     $text = "<div style='text-align:center'>
              <table style='width:94%' class='fborder'>
                  <tr>
                     <td class='forumheader' style='text-align:left; width:20%'>".TS3_ADM_22."</td>
                     <td colspan='6' class='forumheader'>".$return['select']."</td>
                  </tr>
                  <tr>
                     <td colspan='7' class='forumheader'><h3>".TS3_ADM_10.$ts3_ServerInstance.TS3_ADM_11.$selected_sid."</h3></td>
                  </tr>";

     /* get TeamSpeak3_Node_Server object by ID */
     $ts3_VirtualServer = $ts3_ServerInstance->serverGetById($selected_sid);
  }else
  {
     $text = "<div style='text-align:center'>
              <table style='width:94%' class='fborder'>
                  <tr>
                     <td class='forumheader' style='text-align:left; width:20%'>".TS3_ADM_22."</td>
                     <td colspan='6' class='forumheader'>".$return['select']."</td>
                  </tr>
                  <tr>
                     <td colspan='7' class='forumheader'><h3>".TS3_ADM_10.$ts3_ServerInstance.TS3_ADM_11.$ssid."</h3></td>
                  </tr>";

     /* get TeamSpeak3_Node_Server object by ID */
     $ts3_VirtualServer = $ts3_ServerInstance->serverGetById($ssid);

  }

  /* grab the latest build numbers */
  $ts3_UpdateServer = TeamSpeak3::factory("update");

  /* display latest stable build number */
  $text .= "     <tr>
                    <td colspan='7' class='forumheader3'>
                        <b>Latest Client Builds:</b>
                        <b><span><font color='green'>".TS3_ADM_18.$ts3_UpdateServer->getRev()."</font></span>
                        <span><font color='orange'>".TS3_ADM_19.$ts3_UpdateServer->getRev("beta")."</font></span>
                        <span><font color='red'>".TS3_ADM_20.$ts3_UpdateServer->getRev("alpha")."</font></span></b>
                    </td>
                 </tr>
           </table>";

  /* list outdated clients */
  $text .= "
           <table style='width:94%' class='fborder'>
                 <tr>
                     <td class='forumheader2'>".TS3_ADM_12."</td>
                     <td class='forumheader2'>".TS3_ADM_13."</td>
                     <td class='forumheader2'>".TS3_ADM_14."</td>
                     <td class='forumheader2'>".TS3_ADM_15."</td>
                     <td class='forumheader2'>".TS3_ADM_16."</td>
                     <td class='forumheader2'>".TS3_ADM_17."</td>
                 </tr>";

  foreach($ts3_VirtualServer->clientList() as $client)
  {
    
    if(($client["client_type"]) || ($client->getRev() >= $ts3_UpdateServer->getRev())) continue;
    $client_alt = $client->getIcon();

    $text .= "   <tr>
                     <td class='forumheader3'>".$client->getId()."</td>
                     <td class='forumheader3'>".htmlspecialchars($client)."&nbsp;&nbsp;<img src='./images/flags/".strtolower($client["client_country"]).".png' alt='".$client["client_country"]."' align='right' /></td>
                     <td class='forumheader3'>".htmlspecialchars($client["client_unique_identifier"])."</td>
                     <td class='forumheader3'><img src='./images/viewer/".$client->getIcon().".png' alt='".$client_alt."' /></td>
                     <td class='forumheader3'>".$client["client_platform"]."</td>
                     <td class='forumheader3'>".$client["client_version"]."</td>
                 </tr>";
  }

  //Client not Outdated
  $text .= "    <tr>
                     <td colspan='7'>&nbsp;</td>
                </tr>
            </table>
            <table style='width:94%' class='fborder'>
                 <tr>
                     <td colspan='7' class='forumheader'><h3>".TS3_ADM_21.$ts3_ServerInstance.TS3_ADM_11.$selected_sid."</h3></td>
                 </tr>
                 <tr>
                     <td class='forumheader3'>".TS3_ADM_12."</td>
                     <td class='forumheader3'>".TS3_ADM_13."</td>
                     <td class='forumheader3'>".TS3_ADM_14."</td>
                     <td class='forumheader3'>".TS3_ADM_15."</td>
                     <td class='forumheader3'>".TS3_ADM_16."</td>
                     <td class='forumheader3'>".TS3_ADM_17."</td>
                 </tr>";

  foreach($ts3_VirtualServer->clientList() as $client)
  {
    if(($client["client_type"]) || ($client->getRev() <> $ts3_UpdateServer->getRev())) continue;
    $client_alt = $client->getIcon();
    $text .= "   <tr>
                     <td class='forumheader3'>".$client->getId()."</td>
                     <td class='forumheader3'>".htmlspecialchars($client)."&nbsp;&nbsp;<img src='./images/flags/".strtolower($client["client_country"]).".png' alt='".$client["client_country"]."' align='right' /></td>
                     <td class='forumheader3'>".htmlspecialchars($client["client_unique_identifier"])."</td>
                     <td class='forumheader3'><img src='./images/viewer/".$client->getIcon().".png' alt='".$client_alt."' /></td>
                     <td class='forumheader3'>".$client["client_platform"]."</td>
                     <td class='forumheader3'>".$client["client_version"]."</td>
                 </tr>";
  }

  /* display runtime from adapter profiler */
     $text .= "  <tr>
                    <td colspan='7' class='forumheader3'>
                        Executed " . $ts3_ServerInstance->getAdapter()->getQueryCount() . " queries in " . $ts3_ServerInstance->getAdapter()->getQueryRuntime() . " seconds
                        <td>
                 </tr>
                 <tr>
                     <td colspan='7'>&nbsp;</td>
                </tr>
           <table></div>";
     

    /* Send poke msg to a client */
    $text .= "<div style='text-align:center'>
              <table style='width:94%' class='fborder'>
                 <tr>
                     <td colspan='7' class='forumheader3'>
                        <form action='admin_client.php' method='post'>
                            <input type='hidden' name='ssid' value='".$selected_sid."' />
                            ID: <input type='text' name='cid' maxlength='4' size='4' />&nbsp;&nbsp;
                            Poke msg: <input type='text' name='poke' maxlength='150' size='50' />&nbsp;&nbsp;
                            <input type='submit' name='send' value='Submit' />
                       </form>


                     </td>
                 </tr>
              <table></div>";

}

//If error, display it
catch(Exception $e)
{
  $error = "Error (ID " . $e->getCode() . ") <b>" . $e->getMessage() . "</b>";
  $ns -> tablerender('Error', $error);
}

// ===== END settings =======
//-----------------------------------------------------------------------------------------------------
$ns -> tablerender("<div style='text-align:center'>".TS3W_01."</div>", $text);
require_once(e_ADMIN."footer.php");
//================ END ==================================================================================================
//
//============== Function ===============================================================================================

function form_server_selector(array $servers, $ssid)
{
  
  if($ssid == "0")
  {
     $selected_sid = get_param("server", 0);
  }else
  {
     $selected_sid = $ssid;
  }


  if(!$selected_sid && count($servers))
  {
    $selected_sid = current($servers)->getId();
  }

  $output = "<form action='admin_client.php' method='get'>" .
            "<select name=\"server\">\n";

  foreach($servers as $sid => $server)
  {
    $output .= "<option value=\"" . $sid . "\"" . ($selected_sid == $sid ? " selected=selected" : "") . ">" . htmlspecialchars($server) . "</option>\n";
  }

  $output .= "</select>\n" .
       "<input type=\"submit\" value=\"Go\" />\n" .
       "</form>\n" .
       "<br />\n";

  $return['sid'] = $selected_sid;
  $return['select'] = $output;

  return $return;
}


function get_param($key, $default = null)
{
  return (array_key_exists($key, $_GET) && !empty($_GET[$key])) ? preg_replace("/[^[:graph:]]/", "", $_GET[$key]) : $default;
}

/**
 * Converts each element of an array to produce valid HTML code.
 *
 * @param  array $array
 * @return array
 */
function htmlspecialchars_array(array $array)
{
  foreach($array as $key => $val) {
    $array[$key] = (is_array($val)) ? htmlspecialchars_array($val) : htmlspecialchars($val);
  }

  return $array;
}
?>