<?php
/*
+---------------------------------------------------------------+
|	For e107 website system
|	Teamspeak 3 Viewer for e107
|       Based on TeamSpeak 3 PHP Framework by ScP
|	http://forum.teamspeak.com/showthread.php?t=48162
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/
$eplug_admin = true;
if(!defined("e107_INIT")) {
	require_once("../../class2.php");
}

//For admin menu and v0.7
        $pageid = "ts3client";  // unique name that matches the one used in admin_menu.php.
$eplug_css="";

if(!getperms("P")){ header("location:".e_BASE."index.php");}
require_once(e_ADMIN."auth.php");

// Set languages --------------------------------------------+
$ec_dir = e_PLUGIN."teamspeak3_menu/";
$lan_file = $ec_dir."/languages/".e_LANGUAGE.".php";
include(file_exists($lan_file) ? $lan_file : e_PLUGIN."teamspeak3_menu/languages/English.php");

// Main settings -----------------------------------------+
/* load framework library and other*/
$style = "";
$wstyle = "";
require_once("libraries/TeamSpeak3/TeamSpeak3.php");
/* initialize */
TeamSpeak3::init();

try
{
  
  /* connect to server, login and get TeamSpeak3_Node_Host object by URI */
  $ts3_ServerInstance = TeamSpeak3::factory("serverquery://" . $pref['ts3_user'] . ":" . $pref['ts3_pass'] . "@" . $pref['ts3_ip'] . ":" . $pref['ts3_port'] . "/");

  /* display server select form */
  $return = form_server_selector($ts3_ServerInstance->serverList());
  
  $selected_sid = $return['sid'];
  $text = "<div style='text-align:center'>
           <table style='width:94%' class='fborder'>
                 <tr>
                     <td class='forumheader' style='text-align:left; width:20%'>".TS3_ADM_22."</td>
                     <td colspan='3' class='forumheader'>".$return['select']."</td>
                  </tr>
                 <tr>
                     <td colspan='4' class='forumheader'><h3>".TS3_ADM_23.$ts3_ServerInstance.TS3_ADM_11.$selected_sid."</h3></td>
                 </tr>
           </table>";

  /* get TeamSpeak3_Node_Server object by ID */
  $ts3_VirtualServer = $ts3_ServerInstance->serverGetById($selected_sid);

  /* display server logs */
  $text .= "<table style='width:94%' class='fborder'>
                 <tr>
                      <td class='forumheader2' style='text-align:left; width:20%'><b>".TS3_ADM_24."</b></td>
                      <td class='forumheader2'><b>".TS3_ADM_25."</b></td>
                      <td class='forumheader2'><b>".TS3_ADM_26."</b></td>
                      <td class='forumheader2'><b>".TS3_ADM_27."</b></td>
                 </tr>";

  foreach($ts3_VirtualServer->logView(250) as $log)
  {
    $level = TeamSpeak3_Helper_Convert::logLevel($log["level"]);

    
    Switch($level)
    {
       //Mark Error
       case((strtolower($level) === "warning") || (strtolower($level) === "error") || (strtolower($level) === "critical")):
                $style  = "color:#FF4500; font-weight:bold";
                $wstyle = "color:#FF4500; font-weight:bold; ";
                break;
       
       //Mark Virtual sever action
       case(strtolower($log["channel"]) === "virtualserver"):
                $style  = "color:green; font-weight:bold";
                $wstyle = "color:green; font-weight:bold; ";
                break;
                
       //Mark when updated query_ip_whitelist ips
       case(strtolower($log["channel"]) === "cidrmanager"):
                $style  = "color:#0000ff; font-weight:bold";
                $wstyle = "color:#0000ff; font-weight:bold; ";
                break;

       //Mark Filemanager
       case(strtolower($log["channel"]) === "filemanager"):
                $style  = "color:#aa5500; font-weight:bold";
                $wstyle = "color:#aa5500; font-weight:bold; ";
                break;

       default:
               $style = "";
               $wstyle = "";
               break;
    }

    $text .= "<tr>
                  <td class='forumheader3' style='".$wstyle."text-align:left; width:20%'>".date(DATE_ATOM, $log["timestamp"])."</td>
                  <td class='forumheader3' style='".$style."'>".$level."</td>
                  <td class='forumheader3' style='".$style."'>".$log["channel"]."</td>
                  <td class='forumheader3' style='".$style."'>".$log["msg"]."</td>
             </tr>";
  }

  /* display runtime from adapter profiler */
     $text .= "  <tr>
                    <td colspan='7' class='forumheader3'>
                       Executed " . $ts3_ServerInstance->getAdapter()->getQueryCount() . " queries in " . $ts3_ServerInstance->getAdapter()->getQueryRuntime() . " seconds
                    </td>
                 </tr>
           <table></div>";
}

//If error, display it
catch(Exception $e)
{
  $error = "Error (ID " . $e->getCode() . ") <b>" . $e->getMessage() . "</b>";
  $ns -> tablerender('Error', $error);
}

// ===== END settings =======
//-----------------------------------------------------------------------------------------------------
$ns -> tablerender("<div style='text-align:center'>".TS3W_01."</div>", $text);
require_once(e_ADMIN."footer.php");
//================ END ==================================================================================================
//
//============== Function ===============================================================================================
function form_server_selector(array $servers)
{
  $selected_sid = get_param("server", 0);


  if(!$selected_sid && count($servers))
  {
    $selected_sid = current($servers)->getId();
  }

  $output = "<form action='admin_qrylog.php' method='get'>" .
            "<select name=\"server\">\n";

  foreach($servers as $sid => $server)
  {
    $output .= "<option value=\"" . $sid . "\"" . ($selected_sid == $sid ? " selected=selected" : "") . ">" . htmlspecialchars($server) . "</option>\n";
  }

  $output .= "</select>\n" .
       "<input type=\"submit\" value=\"Go\" />\n" .
       "</form>\n" .
       "<br />\n";

  $return['sid'] = $selected_sid;
  $return['select'] = $output;

  return $return;
}
function get_param($key, $default = null)
{
  return (array_key_exists($key, $_GET) && !empty($_GET[$key])) ? preg_replace("/[^[:graph:]]/", "", $_GET[$key]) : $default;
}

/**
 * Converts each element of an array to produce valid HTML code.
 *
 * @param  array $array
 * @return array
 */
function htmlspecialchars_array(array $array)
{
  foreach($array as $key => $val) {
    $array[$key] = (is_array($val)) ? htmlspecialchars_array($val) : htmlspecialchars($val);
  }

  return $array;
}

?>