<?php
/*
+---------------------------------------------------------------+
|	For e107 website system
|	Teamspeak 3 Viewer for e107
|       Based on TeamSpeak 3 PHP Framework by ScP
|	http://forum.teamspeak.com/showthread.php?t=48162
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/

// This must be included first, since other libs depend upon it.
require_once("../../class2.php");
if (!defined('e107_INIT')) { exit(); }

/* load framework library */
require_once("libraries/TeamSpeak3/TeamSpeak3.php");

/* initialize */
TeamSpeak3::init();

$eplug_css="style.css";

$text = "";

// Set languages --------------------------------------------+
$ec_dir = e_PLUGIN."teamspeak3_menu/";
$lan_file = $ec_dir."/languages/".e_LANGUAGE.".php";
include(file_exists($lan_file) ? $lan_file : e_PLUGIN."teamspeak3_menu/languages/English.php");

require_once(HEADERF);


while(list($key, $ts3_info) = each($pref['ts3']))
{
      $text = "";
      $name  = $ts3_info['tsw_name'];
      $ip    = $ts3_info['tsw_ip'];
      $oip    = $ts3_info['tsw_oip'];
      $port  = $ts3_info['tsw_port'];
      $qport = $ts3_info['tqw_port'];

   try
   {
     // Connect TS server and get data
     $ts3_VirtualServer =  TeamSpeak3::factory("serverquery://".$ip.":".$qport."/?server_port=".$port."#no_query_clients");
     

     //Show every server instance

           $uptime = $ts3_VirtualServer["virtualserver_uptime"];
           $day = ($uptime/1000/60/60/24) %1;
           $tim = ($uptime/1000/60/60)%24;
           $min = ($uptime/1000/60)%60;
           $server_uptime = $day." Days ".$tim.' Hours '.$min.' Min';
           $online = $ts3_VirtualServer["virtualserver_status"];


           if($ts3_VirtualServer["virtualserver_flag_password"] == '1')
           {
             $password = "<b><font color='red'>".TS3W_11."</font></b>";
           }else
           {
             $password = "<b><font color='green'>".TSW3_12."</font></b>";
           }

           if($online == 'online')
           {
             $online_status = "<b><font color='green'>".$online."</font></b>";
           }else
           {
             $online_status = "<b><font color='red'>".$online."</font></b>";
           }

           //If a host banner is defined show it
           if ($ts3_VirtualServer["virtualserver_hostbanner_url"] != "")
           {
              $text .= "<div align='center'><a href='".$ts3_VirtualServer["virtualserver_hostbanner_url"]."' target='_blank'><img src='".$ts3_VirtualServer["virtualserver_hostbanner_gfx_url"]."' width='150' higth='10' alt='".$ts3_VirtualServer["virtualserver_hostbanner_url"]."' /></a><br /><br /><b>".$ts3_VirtualServer["virtualserver_name"]."</b><br /><br /></div>";
           }else
           {
              $text .=  "<div align='center'><b>".$ts3_VirtualServer["virtualserver_name"]."</b><br /><br /></div>";
           }

           $text .= "<table style='width:50%'>
                        <tr valign='top'>
                           <td>

		              <table style='width:400px' class='fborder'>

                                 <tr>
                                   <td colspan='2' class='forumheader'>
                                        <b>".TS3W_13."</b>
                                   </td>
                                 </tr>
                                 
                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_14."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$online_status."
                                    </td>
                                 </tr>
                                 
                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_27."
                                    </td>
                                   <td style='width:40%' class='forumheader2'><a href='ts3server://".$oip.":".$port."'>".$oip.":".$port."</a>
                                    </td>
                                 </tr>

                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_15."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$ts3_VirtualServer["virtualserver_welcomemessage"]."
                                    </td>
                                 </tr>
                                 
                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_16."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$password."
                                    </td>
                                 </tr>
                                 
                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_17."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$ts3_VirtualServer["virtualserver_platform"]."
                                    </td>
                                 </tr>

                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_18."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$server_uptime."
                                    </td>
                                 </tr>

                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_19."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".date('d M Y', $ts3_VirtualServer["virtualserver_created"])."
                                    </td>
                                 </tr>

                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_20."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$ts3_VirtualServer["virtualserver_channelsonline"]."
                                    </td>
                                 </tr>



                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_21."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$ts3_VirtualServer->clientCount()." / ". $ts3_VirtualServer["virtualserver_maxclients"]."
                                    </td>
                                 </tr>
                                 


				     <tr>
                                    <td style='width:10%' class='forumheader2'>
                                        ".TS3W_22."
                                    </td>
                                   <td style='width:40%' class='forumheader2'>".$ts3_VirtualServer["virtualserver_client_connections"]."
                                    </td>
                                 </tr>
                                 
                                 <tr>
                                    <td style='width:10%' class='forumheader2'>
                                       ".TS3W_23."</td><td style='width:40%' class='forumheader2'>".$ts3_VirtualServer["connection_packets_received_total"]." / ".$ts3_VirtualServer["connection_bytes_received_total"]."
                                   </td>
                                </tr>
                                
                                <tr>
                                   <td style='width:10%' class='forumheader2'>
                                      ".TS3W_24."</td><td style='width:40%' class='forumheader2'>".$ts3_VirtualServer["connection_packets_sent_total"]." / ".$ts3_VirtualServer["connection_bytes_sent_total"]."
                                   </td>
                                </tr>

                              </table>
                             </td>
                            
				<td />
	                     <td>
                             
                              <table style='width:200px' class='fborder'>
                               
                               <tr>
                                 <td class='forumheader'>
                                     ".TS3W_25."
                                </td>
                              </tr>

				    <tr>
                                  <td height='20' nowrap='nowrap' style='padding: 3px;'>".$ts3_VirtualServer->getViewer(new TeamSpeak3_Viewer_Html("images/viewer/"))."
                                  </td>
                               </tr>

                             </table>
			    	
		           </td>
                        </tr>
                     </table><hr /><br /><br />";
                     $ns -> tablerender("<b>".$name."</b>", $text);

     
     }
     //If error, display it
     catch(Exception $e)
    {
        $text .= "Error (ID " . $e->getCode() . ") <b>" . $e->getMessage() . "</b>
                  <hr /><center><img src='images/no_response.jpg' /></center>";
                  $ns -> tablerender("<b>".$name."</b>", $text);
    }

}




//$ns -> tablerender(TS3W_01, $text);
require_once(FOOTERF);
?>